/*
 * Copyright ©Rastislav Mirek. All rights reserved.
 * No waranty for this software or derived works.
 */

package cz.muni.fi.pb162.graphicalobjectexample.graphicalobjects;

/**
 * This class represents Coordinate.
 *
 * Created 28.10.2009 at 13:48:42.
 *
 * @author Rastislav Mirek <rmirek at mail.muni.cz>
 * @version %I%, %G%
 * @since 1.0
 */
public class Coordinate {
    private int x;
    private int y;

    public Coordinate(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public double getDistance(int xOfGoal, int yOfGoal){
        return Math.sqrt(sq(x - xOfGoal) + sq(y - yOfGoal));
    }

    public double distanceTo(Coordinate toCoordinate){
        return getDistance(toCoordinate.getX(), toCoordinate.getY());
    }

    private double sq(double root){
        return root * root;
    }

    @Override
    public boolean equals(Object obj) {
        if(obj == this){ // this condition is here unnecessary, hovewer it is sometimes used because it improves efectivity
            return true;
        }
        if(obj == null){
            return false;
        }
        if(!(obj instanceof Coordinate)){
            return false;
        }

        Coordinate other = (Coordinate) obj;
        return other.x == x && other.y == y; //DIRECT ACCESS TO ATRIBUTES OF OTHER OBJECT! It is only acceptable(and very correct) in equals method.
        //hovewer in this case it is also possible to use getters methods
    }

    @Override
    public int hashCode(){
        return 3 * x + 5 * y;
    }

    @Override
    public String toString() {
        return "[" + x + "," + y + "]";
    }

}
