/*
 * GraphicalObjectExampleApp.java
 */

package cz.muni.fi.pb162.graphicalobjectexample.viewer;

import cz.muni.fi.pb162.graphicalobjectexample.graphicalobjects.GraphicalObject;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class GraphicalObjectViewer extends SingleFrameApplication {

    private static GraphicalObjectDisplayer displayer;

    public static void setDisplayer(GraphicalObjectDisplayer displayer) {
        GraphicalObjectViewer.displayer = displayer;
    }


    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        show(new GraphicalObjectExampleView(this, displayer));
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of GraphicalObjectExampleApp
     */
    public static GraphicalObjectViewer getApplication() {
        return Application.getInstance(GraphicalObjectViewer.class);
    }

    /**
     * Main method launching the application.
     */
    public static void start() {
        launch(GraphicalObjectViewer.class, new String[]{});
        displayer.repaint();
    }

    public void addGraphicalObject(GraphicalObject newGraphicalObject){
        displayer.install(newGraphicalObject);
    }


}
